﻿using Styx;
using Styx.Common;
using Styx.CommonBot.Frames;
using Styx.Pathing;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using System.Numerics;

namespace MothersKnife
{
    class Main : HBPlugin
    {
        //super super non important information!
        public override string Name { get { return "Mothers Knife - Exocet"; } }
        public override string Author { get { return "Exocet"; } }
        public override string ButtonText { get { return "Settings"; } }
        public override bool WantButton { get { return true; } }
        public override Version Version { get { return new Version(0, 0, 1); } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        //define the skinner is a leet skinner
        private static bool Skinner;

        // set the amazing list of lists for lists that list a knife....
        private List<uint> mothersknifeArangList = new List<uint>(new uint[] {
            130102 //http://www.wowhead.com/item=130102/mothers-skinning-knife
		});

        //Define lootable corpses
        private IOrderedEnumerable<WoWUnit> LootableCorpses
        {
            get
            {
                var lootList = ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Where(
                        b => (b.Lootable || (b.CanSkin && Skinner)) && b.Distance >= 40).OrderBy(l => l.Distance);

                return lootList;
            }
        }

        // Logging cool things for cool people!
        private void Log(string log, bool error)
        {
            if (error)
            {
                Logging.Write(Colors.Red, Name + " " + Version + " - " + log);
            }
            else
            {
                Logging.Write(Colors.OrangeRed, Name + " " + Version + " - " + log);
            }
        }

        // How do i use this thing?
        private void useMothersKnife()
        {
            var lootTarget = LootableCorpses.FirstOrDefault();
            if (getMothersKnife() != null & lootTarget != null)
            {
                if (lootTarget.Lootable)
                {
                    Log("Using " + getMothersKnife().SafeName + "!", false);
                    getMothersKnife().UseContainerItem();
                }
            }
        }

        // What the hell is a mothers knife!!!! HELP ME!
        private WoWItem getMothersKnife()
        {
            foreach (uint i in mothersknifeArangList)
            {
                WoWItem MothersKnife = StyxWoW.Me.BagItems.FirstOrDefault(r => r.Entry == i);
                if (MothersKnife != null)
                {
                    var lootCD = new TimeSpan(0, 0, 0);
                    if (MothersKnife.CooldownTimeLeft <= lootCD)
                    {
                        return MothersKnife;
                    }
                }
                continue;
            }
            return null;
        }

        //do things to make me happy plz.
        public override void Pulse()
        {
            try
            {
                if (!StyxWoW.Me.IsCasting && LootableCorpses.Count() > 0 && !StyxWoW.Me.IsMoving && !StyxWoW.Me.Combat)
                {
                    if (LootFrame.Instance != null && LootFrame.Instance.IsVisible)
                    {
                        LootFrame.Instance.LootAll();
                    }
                    var lootTarget = LootableCorpses.FirstOrDefault();

                    if (lootTarget.Distance > lootTarget.InteractRange)
                    {
                        Logging.Write("Moving to loot {0}.", lootTarget.Name);
                        Navigator.MoveTo(lootTarget.Location);
                    }
                    else
                    {
                        lootTarget.Interact();
                        Logging.Write("Using Mothers Knife on {0}.", lootTarget.Name);
                        useMothersKnife();
                    }
                }
            }

            catch (Exception e)
            {
                Logging.Write("Pulse: " + e);
            }
        }
    }

}
